/*
 * @Author: zhenxing xiezhenxing@codvision.com
 * @Date: 2022-06-09 10:21:46
 * @LastEditors: zhenxing xiezhenxing@codvision.com
 * @LastEditTime: 2022-06-09 10:26:06
 * @FilePath: \组件库\src\pages\MapComponent\OlTest\components\OlMyMap\mapTools\UseCoordinate\index.js
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
/* eslint-disable no-param-reassign */
const __read = (this && this.__read) || function (o, n) {
    let m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    let i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i.return)) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import * as proj from 'ol/proj';
import { bd09togcj02, bd09towgs84, gcj02tobd09, gcj02towgs84, out_of_china, wgs84togcj02 } from '../utils/pointerTransfroms';
/**
 * 点位处理工具
 */
const UseCoordinate = /** @class */ (function () {
    function UseCoordinate() {
        /**
         * 4326转3857
         * @param coordinate 点位
         */
        this.set4326to3857 = function (coordinate) {
            const _a = __read(coordinate, 2), lng = _a[0], lat = _a[1];
            if (!lat || !lng)
                return null;
            const newpoint = proj.transform(coordinate, 'EPSG:4326', 'EPSG:3857');
            return newpoint;
        };
        /**
         * 3857转4326
         * @param coordinate 点位
         */
        this.set3857to4326 = function (coordinate) {
            const _a = __read(coordinate, 2), lng = _a[0], lat = _a[1];
            if (!lat || !lng)
                return null;
            const newpoint = proj.transform(coordinate, 'EPSG:3857', 'EPSG:4326');
            return newpoint;
        };
        /**
         * 百度坐标系 (BD-09) 与 火星坐标系 (GCJ-02)的转换
         * 即 百度 转 谷歌、高德
         * @param bd_lon
         * @param bd_lat
         * @returns [lng,lat]
         */
        this.bd09togcj02 = bd09togcj02;
        /**
         * 百度坐标转wgs84
         * @param {*} lng
         * @param {*} lat
         * @returns [lng,lat]
         */
        this.bd09towgs84 = bd09towgs84;
        /**
         * 火星坐标系 (GCJ-02) 与百度坐标系 (BD-09) 的转换
         * 即谷歌、高德 转 百度
         * @param lng
         * @param lat
         * @returns [lng,lat]
         */
        this.gcj02tobd09 = gcj02tobd09;
        /**
         * WGS84转GCj02
         * @param lng
         * @param lat
         * @returns [lng,lat]
         */
        this.wgs84togcj02 = wgs84togcj02;
        /**
         * GCJ02 转换为 WGS84
         * @param lng
         * @param lat
         * @returns [lng,lat]
         */
        this.gcj02towgs84 = gcj02towgs84;
        /**
         * 判断是否在国内，不在国内则不做偏移
         * @param lng
         * @param lat
         * @returns {boolean}
         */
        this.outOfChina = out_of_china;
    }
    return UseCoordinate;
}());
export default UseCoordinate;
