/* eslint-disable no-param-reassign */
/* eslint-disable prefer-const */
const __read = function (o: any, n: any) {
  let m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  let i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  }
  catch (error) { e = { error: error }; }
  finally {
    try {
      if (r && !r.done && (m = i.return)) m.call(i);
    }
    finally { if (e) throw e.error; }
  }
  return ar;
};
import * as proj from 'ol/proj';
import { bd09togcj02, bd09towgs84, gcj02tobd09, gcj02towgs84, out_of_china, wgs84togcj02 } from '../utils/pointerTransfroms';

const UseCoordinate = {
  /**
 * 4326转3857
 * @param coordinate 点位
 */
  set4326to3857: (coordinate: any) => {
    const _a = __read(coordinate, 2), lng = _a[0], lat = _a[1];
    if (!lat || !lng)
      return null;
    const newpoint = proj.transform(coordinate, 'EPSG:4326', 'EPSG:3857');
    return newpoint;
  },
  /**
 * 3857转4326
 * @param coordinate 点位
 */
  set3857to4326: (coordinate: any) => {
    const _a = __read(coordinate, 2), lng = _a[0], lat = _a[1];
    if (!lat || !lng)
      return null;
    const newpoint = proj.transform(coordinate, 'EPSG:3857', 'EPSG:4326');
    return newpoint;
  },
  /**
 * 百度坐标系 (BD-09) 与 火星坐标系 (GCJ-02)的转换
 * 即 百度 转 谷歌、高德
 * @param bd_lon
 * @param bd_lat
 * @returns [lng,lat]
 */
  bd09togcj02: bd09togcj02,
  /**
   * 百度坐标转wgs84
   * @param {*} lng
   * @param {*} lat
   * @returns [lng,lat]
   */
  bd09towgs84: bd09towgs84,
  /**
   * 火星坐标系 (GCJ-02) 与百度坐标系 (BD-09) 的转换
   * 即谷歌、高德 转 百度
   * @param lng
   * @param lat
   * @returns [lng,lat]
   */
  gcj02tobd09: gcj02tobd09,
  /**
   * WGS84转GCj02
   * @param lng
   * @param lat
   * @returns [lng,lat]
   */
  wgs84togcj02: wgs84togcj02,
  /**
   * GCJ02 转换为 WGS84
   * @param lng
   * @param lat
   * @returns [lng,lat]
   */
  gcj02towgs84: gcj02towgs84,
  /**
   * 判断是否在国内，不在国内则不做偏移
   * @param lng
   * @param lat
   * @returns {boolean}
   */
  outOfChina: out_of_china,

}
export default UseCoordinate;