// wgs与高德互转// 准确性高
const WGS84MrGcj02 = {
  pi: 3.14159265358979324,
  a: 6378245.0,
  ee: 0.00669342162296594323,
  /*判断是否在国内，不在国内则不做偏移*/
  outOfChina(lon: number | string, lat: number | string) {
    if ((+lon < 72.004 || +lon > 137.8347) && (+lat < 0.8293 || +lat > 55.8271)) {
      return true;
    } else {
      return false;
    }
  },
  transformLat(x: number, y: number) {
    let ret = -100.0 + 2.0 * x + 3.0 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(Math.abs(x));
    ret += (20.0 * Math.sin(6.0 * x * this.pi) + 20.0 * Math.sin(2.0 * x * this.pi)) * 2.0 / 3.0;
    ret += (20.0 * Math.sin(y * this.pi) + 40.0 * Math.sin(y / 3.0 * this.pi)) * 2.0 / 3.0;
    ret += (160.0 * Math.sin(y / 12.0 * this.pi) + 320 * Math.sin(y * this.pi / 30.0)) * 2.0 / 3.0;
    return ret;
  },
  transformLon(x: number, y: number) {
    var ret = 300.0 + x + 2.0 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(Math.abs(x));
    ret += (20.0 * Math.sin(6.0 * x * this.pi) + 20.0 * Math.sin(2.0 * x * this.pi)) * 2.0 / 3.0;
    ret += (20.0 * Math.sin(x * this.pi) + 40.0 * Math.sin(x / 3.0 * this.pi)) * 2.0 / 3.0;
    ret += (150.0 * Math.sin(x / 12.0 * this.pi) + 300.0 * Math.sin(x / 30.0 * this.pi)) * 2.0 / 3.0;
    return ret;
  },
  // wgs转高德
  wgs84ToGcj02(wgLon: number, wgLat: number) {
    const mars_point = { lon: 0, lat: 0 };
    if (this.outOfChina(wgLon, wgLat)) {
      mars_point.lat = +wgLat;
      mars_point.lon = +wgLon;
      return;
    }
    let dLat = this.transformLat(wgLon - 105.0, wgLat - 35.0);
    let dLon = this.transformLon(wgLon - 105.0, wgLat - 35.0);
    const radLat = wgLat / 180.0 * this.pi;
    let magic = Math.sin(radLat);
    magic = 1 - this.ee * magic * magic;
    const sqrtMagic = Math.sqrt(magic);
    dLat = (dLat * 180.0) / ((this.a * (1 - this.ee)) / (magic * sqrtMagic) * this.pi);
    dLon = (dLon * 180.0) / (this.a / sqrtMagic * Math.cos(radLat) * this.pi);
    mars_point.lat = wgLat + dLat;
    mars_point.lon = wgLon + dLon;
    return mars_point
  },
  // 高德转wgs
  GCJ02ToWGS84(gcjLon: number, gcjLat: number) {
    let d = this.delta(gcjLat, gcjLon)
    return {
      'lat': gcjLat - d.lat,
      'lon': gcjLon - d.lon
    }
  },
  delta(lat: number, lon: number) {
    let dLat = this.transformLat(lon - 105.0, lat - 35.0)
    let dLon = this.transformLon(lon - 105.0, lat - 35.0)
    let radLat = lat / 180.0 * this.pi
    let magic = Math.sin(radLat)
    magic = 1 - this.ee * magic * magic
    let sqrtMagic = Math.sqrt(magic)
    dLat = (dLat * 180.0) / ((this.a * (1 - this.ee)) / (magic * sqrtMagic) * this.pi)
    dLon = (dLon * 180.0) / (this.a / sqrtMagic * Math.cos(radLat) * this.pi)
    return {
      'lat': dLat,
      'lon': dLon
    }
  }
}
export default WGS84MrGcj02;