/*
 * @Author: zhenxing xiezhenxing@codvision.com
 * @Date: 2022-06-16 11:47:20
 * @LastEditors: zhenxing xiezhenxing@codvision.com
 * @LastEditTime: 2022-06-23 16:23:06
 * @FilePath: \组件库\src\components\OlMyMap\config.ts
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
import * as olStyle from 'ol/style';
import {
  FullScreen,
  Attribution,
  MousePosition,
  OverviewMap,
  Rotate,
  ScaleLine,
  Zoom,
  ZoomSlider,
  ZoomToExtent,
} from 'ol/control';
/** 默认工具配置 */
export const TOOLSDATA = {
  FullScreen: new FullScreen(),
  Attribution: new Attribution(),
  MousePosition: new MousePosition(),
  OverviewMap: new OverviewMap(),
  Rotate: new Rotate(),
  ScaleLine: new ScaleLine(),
  Zoom: new Zoom(),
  ZoomSlider: new ZoomSlider(),
  ZoomToExtent: new ZoomToExtent(),
};
/** 默认text配置 */
export const DEFAULTTEXT = {
  textVisible: true,
  textParam: 'name',
  textOffset: [20, 0],
  textAlign: 'left',
  textBaseline: 'middle',
  font: '12px PingFang',
  textColor: '#fff',
  textBackgroundColor: 'rgba(0,0,0,.5)',
  textPadding: [3, 8, 3, 8],
};
const image = undefined;
/** 默认icon配置 */
export const DEFAULTICON = {
  iconAnchor: [0.5, 30],
  iconAnchorOrigin: 'top-right',
  iconOpacity: 1,
  iconScale: 0.4,
  image: image,
};

const defaultStyle = new olStyle.Style({
  fill: new olStyle.Fill({
    color: 'rgba(255, 255, 255, 0.5)',
  }),
  stroke: new olStyle.Stroke({
    color: '#ffcc33',
    width: 2,
  }),
  image: new olStyle.Circle({
    radius: 7,
    fill: new olStyle.Fill({
      color: '#ffcc33',
    }),
  }),
});

export const DrawDefaultStyle = {
  Polygon: defaultStyle,
  MultiPolygon: defaultStyle,
  LineString: defaultStyle,
  MultiLineString: defaultStyle,
  Point: defaultStyle,
  MultiPoint: defaultStyle,
  Circle: defaultStyle,
  LinearRing: defaultStyle,
  GeometryCollection: defaultStyle,
};

const defaultFun = () => { };

export default defaultFun;
