/*
 * @Author: zhenxing xiezhenxing@codvision.com
 * @Date: 2022-06-09 10:22:38
 * @LastEditors: zhenxing xiezhenxing@codvision.com
 * @LastEditTime: 2022-06-09 10:22:47
 * @FilePath: \组件库\src\pages\MapComponent\OlTest\components\OlMyMap\mapTools\utils\coordinateMoreChildren.js
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
/* eslint-disable no-param-reassign */
var __read = function(o, n) {
  var m = typeof Symbol === 'function' && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o),
    r,
    ar = [],
    e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = { error: error };
  } finally {
    try {
      if (r && !r.done && (m = i['return'])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
};
var __spread = function() {
  for (var ar = [], i = 0; i < arguments.length; i++)
    ar = ar.concat(__read(arguments[i]));
  return ar;
};
/**
 * 返回直线上的n个点
 * @param list {lng:number;lat:number}[]
 * @param size 线段切分的个数 -1
 * @returns
 */
var coordinateMoreChildren = function(list, size) {
  if (size === void 0) {
    size = 40;
  }
  var fn = function(point1, point2) {
    var _a = __read(point1, 2),
      lng1 = _a[0],
      lat1 = _a[1];
    var _b = __read(point2, 2),
      lng2 = _b[0],
      lat2 = _b[1];
    var inLng = Math.abs(lng2 - lng1) / size;
    var inLat = Math.abs(lat2 - lat1) / size;
    var arr = [];
    for (var i = 0; i < size; i += 1) {
      if (i === 0) {
        arr = [point1];
      } else {
        var _c = __read(arr[arr.length - 1], 2),
          lng = _c[0],
          lat = _c[1];
        var newInLng = lng1 < lng2 ? inLng : -inLng;
        var newInLat = lat1 < lat2 ? inLat : -inLat;
        arr = __spread(arr, [[lng + newInLng, lat + newInLat]]);
      }
    }
    return arr;
  };
  var list1 = list.map(function(ele) {
    return [ele.lng, ele.lat];
  });
  var list2 = [];
  for (var i = 0; i < list.length; i += 1) {
    list2.push(list1.slice(i, i + 2));
  }
  if (list2[list.length - 1].length === 1) {
    delete list2[list.length - 1];
  }
  var list3 = [];
  list2.forEach(function(ele) {
    list3 = __spread(list3, fn(ele[0], ele[1]));
  });
  return list3;
};
export default coordinateMoreChildren;
