import * as olStyle from 'ol/style';
import getParams from './getParams';
import { DEFAULTTEXT } from './config';
/** 样式配置 */
var createAreaStyle = function(feature) {
  var _a = getParams(feature, DEFAULTTEXT),
    _b = _a.backgroundColor,
    backgroundColor = _b === void 0 ? 'rgba(137,119,251,0.5)' : _b,
    _c = _a.borderColor,
    borderColor = _c === void 0 ? '#fff' : _c,
    _d = _a.borderSize,
    borderSize = _d === void 0 ? 2 : _d,
    textVisible = _a.textVisible,
    text = _a.text,
    font = _a.font,
    textBaseline = _a.textBaseline,
    textAlign = _a.textAlign,
    textColor = _a.textColor,
    textBackgroundColor = _a.textBackgroundColor,
    textPadding = _a.textPadding;
  return new olStyle.Style({
    fill: new olStyle.Fill({
      color: backgroundColor,
    }),
    stroke: new olStyle.Stroke({
      color: borderColor,
      width: borderSize,
    }),
    text: textVisible
      ? new olStyle.Text({
          textAlign: textAlign,
          textBaseline: textBaseline,
          font: font,
          text: text,
          // 填充样式
          fill: new olStyle.Fill({
            color: textColor,
          }),
          backgroundFill: new olStyle.Fill({
            color: textBackgroundColor,
          }),
          padding: textPadding,
        })
      : undefined,
  });
};
export default createAreaStyle;
