import * as turf from '@turf/turf';
var getList = function (coord) {
    var list = [[]];
    coord.forEach(function (item, index) {
        if (index % 2) {
            list[0].push([coord[index - 1], item]);
        }
    });
    return list;
};
var getArea = function (coord) {
    try {
        var list = getList(coord);
        var py = turf.polygon(list);
        return turf.area(py);
    }
    catch (error) {
        return 0;
    }
};
var getpolyArea = function (list) {
    var newList = list
        .map(function (item, index) { return ({ index: index, area: item, m: getArea(item.flatCoordinates) }); })
        .sort(function (a, b) { return b.m - a.m; })
        .map(function (item) { return item.area; });
    return newList;
};
export default getpolyArea;
