import MultiPolygon from 'ol/geom/MultiPolygon';
import Polygon from 'ol/geom/Polygon';
import readGeometry from './readGeometry';
import writeGeometry from './writeGeometry';
export default (function (orgList) {
    var geoms = new MultiPolygon([]);
    orgList.forEach(function (org) {
        try {
            var geometry = readGeometry(org.wkt || '');
            if (geometry instanceof Polygon) {
                geoms.appendPolygon(geometry);
            }
            else if (geometry instanceof MultiPolygon) {
                geometry.getPolygons().forEach(function (subItem) {
                    geoms.appendPolygon(subItem);
                });
            }
        }
        catch (error) {
            //
        }
    });
    var geomString = writeGeometry(geoms);
    return geomString;
});
